﻿Imports System.Text
Imports System.Net.Sockets

Public Class Form1
    Inherits System.Windows.Forms.Form
    Public receivingUdpClient As UdpClient
    Public RemoteIpEndPoint As New System.Net.IPEndPoint(System.Net.IPAddress.Any, 0)
    Public ThreadReceive As System.Threading.Thread
    Public receivedData As Boolean
    Public pt As ptType
    Public d As Double

    Public Structure ptType
        Dim x As Double
        Dim y As Double
        Dim z As Double
    End Structure

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim port As String
        port = InputBox("Please enter the port you're broadcasting to:")
        Try
            receivedData = True
            receivingUdpClient = New System.Net.Sockets.UdpClient(CInt(port))
            ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
            ThreadReceive.Start()
        Catch x As Exception
            Console.WriteLine(x.Message)
        End Try
    End Sub

    Public Sub ReceiveMessages()
        Try
            receivedData = True
            Dim receiveBytes As [Byte]() = receivingUdpClient.Receive(RemoteIpEndPoint)
            Dim strReturnData As String = System.Text.Encoding.Unicode.GetString(receiveBytes)
            Dim temp() As String
            temp = Split(Encoding.ASCII.GetChars(receiveBytes), ",")

            pt.x = temp(1)
            pt.y = temp(3)
            pt.z = temp(5)

            NewInitialize()
        Catch e As Exception
            Console.WriteLine(e.Message)
        End Try
    End Sub
    Public Sub NewInitialize()
        ThreadReceive = New System.Threading.Thread(AddressOf ReceiveMessages)
        ThreadReceive.Start()
    End Sub

    Private Sub checkDataReceived(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dataTimer.Tick
        If receivedData = False Then
            Exit Sub
        End If

        d = Math.Round(Math.Sqrt(pt.x ^ 2 + pt.y ^ 2 + pt.z ^ 2), 1)
        lblDist.Text = FormatNumber(d, 1) & " in"

        receivedData = False
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        receivingUdpClient.Close()
        End
    End Sub
End Class
